## libsrtp2 2.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(libsrtp2 LANGUAGES C)

set(PACKAGE_VERSION 2.3.0)
set(PACKAGE_STRING "${CMAKE_PROJECT_NAME} ${PACKAGE_VERSION}")

include(TestBigEndian)
include(CheckIncludeFile)
include(CheckFunctionExists)
include(CheckTypeSize)
include(CheckCSourceCompiles)

test_big_endian(WORDS_BIGENDIAN)

if (CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
  set (HAVE_X86 TRUE)
else ()
  set (HAVE_X86 FALSE)
endif ()

check_include_file(arpa/inet.h HAVE_ARPA_INET_H)
check_include_file(byteswap.h HAVE_BYTESWAP_H)
check_include_file(inttypes.h HAVE_INTTYPES_H)
check_include_file(machine/types.h HAVE_MACHINE_TYPES_H)
check_include_file(netinet/in.h HAVE_NETINET_IN_H)
check_include_file(stdint.h HAVE_STDINT_H)
check_include_file(stdlib.h HAVE_STDLIB_H)
check_include_file(sys/int_types.h HAVE_SYS_INT_TYPES_H)
check_include_file(sys/socket.h HAVE_SYS_SOCKET_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(unistd.h HAVE_UNISTD_H)
check_include_file(windows.h HAVE_WINDOWS_H)
check_include_file(winsock2.h HAVE_WINSOCK2_H)

check_function_exists(sigaction HAVE_SIGACTION)
check_function_exists(inet_aton HAVE_INET_ATON)
check_function_exists(usleep HAVE_USLEEP)

check_type_size(uint8_t UINT8_T)
check_type_size(uint16_t UINT16_T)
check_type_size(uint32_t UINT32_T)
check_type_size(uint64_t UINT64_T)
check_type_size(int32_t INT32_T)
check_type_size("unsigned long" SIZEOF_UNSIGNED_LONG)
check_type_size("unsigned long long" SIZEOF_UNSIGNED_LONG_LONG)

check_c_source_compiles("inline void func(); void func() { } int main() { func(); return 0; }" HAVE_INLINE)
if(NOT HAVE_INLINE)
  check_c_source_compiles("__inline void func(); void func() { } int main() { func(); return 0; }" HAVE___INLINE)
endif()

set(ENABLE_DEBUG_LOGGING OFF CACHE BOOL "Enable debug logging in all modules")
set(ERR_REPORTING_STDOUT OFF CACHE BOOL "Enable logging to stdout")
set(ERR_REPORTING_FILE "" CACHE FILEPATH "Use file for logging")
set(ENABLE_OPENSSL OFF CACHE BOOL "Enable OpenSSL crypto engine")
set(TEST_APPS ON CACHE BOOL "Build test applications")
option(BUILD_SHARED_LIBS "Build shared library" OFF)

if(ENABLE_OPENSSL)
  find_package(OpenSSL REQUIRED)
  include_directories(${OPENSSL_INCLUDE_DIR})
endif()
set(OPENSSL ${ENABLE_OPENSSL} CACHE BOOL INTERNAL)
set(GCM ${ENABLE_OPENSSL} CACHE BOOL INTERNAL)

set(CONFIG_FILE_DIR ${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CONFIG_FILE_DIR})

configure_file(config_in_cmake.h ${CONFIG_FILE_DIR}/config.h)
add_definitions(-DHAVE_CONFIG_H)

set(SOURCES_C
  srtp/ekt.c
  srtp/srtp.c
)

set(CIPHERS_SOURCES_C
  crypto/cipher/cipher.c
  crypto/cipher/null_cipher.c
)

if(ENABLE_OPENSSL)
  list(APPEND CIPHERS_SOURCES_C
    crypto/cipher/aes_icm_ossl.c
    crypto/cipher/aes_gcm_ossl.c
  )
else()
  list(APPEND  CIPHERS_SOURCES_C
    crypto/cipher/aes.c
    crypto/cipher/aes_icm.c
  )
endif()

set(HASHES_SOURCES_C
    crypto/hash/auth.c
    crypto/hash/null_auth.c
)

if(ENABLE_OPENSSL)
  list(APPEND HASHES_SOURCES_C
    crypto/hash/hmac_ossl.c
  )
else()
  list(APPEND  HASHES_SOURCES_C
    crypto/hash/hmac.c
    crypto/hash/sha1.c
  )
endif()

set(KERNEL_SOURCES_C
  crypto/kernel/alloc.c
  crypto/kernel/crypto_kernel.c
  crypto/kernel/err.c
  crypto/kernel/key.c
)

set(MATH_SOURCES_C
  crypto/math/datatypes.c
  crypto/math/stat.c
)

set(REPLAY_SOURCES_C
  crypto/replay/rdb.c
  crypto/replay/rdbx.c
  crypto/replay/ut_sim.c
)

set(SOURCES_H
  crypto/include/aes.h
  crypto/include/aes_icm.h
  crypto/include/alloc.h
  crypto/include/auth.h
  crypto/include/cipher.h
  crypto/include/cipher_types.h
  crypto/include/crypto_kernel.h
  crypto/include/crypto_types.h
  crypto/include/datatypes.h
  crypto/include/err.h
  crypto/include/hmac.h
  crypto/include/integers.h
  crypto/include/key.h
  crypto/include/null_auth.h
  crypto/include/null_cipher.h
  crypto/include/rdb.h
  crypto/include/rdbx.h
  crypto/include/sha1.h
  crypto/include/stat.h
  include/srtp.h
  include/srtp_priv.h
  include/ut_sim.h
  ${CONFIG_FILE_DIR}/config.h
)

if(BUILD_SHARED_LIBS AND WIN32)
  list(APPEND SOURCES_C
    srtp.def
  )
endif()

source_group("src" FILES ${SOURCES_C})
source_group("src\\Ciphers" FILES ${CIPHERS_SOURCES_C})
source_group("src\\Hashes" FILES ${HASHES_SOURCES_C})
source_group("src\\Kernel" FILES ${KERNEL_SOURCES_C})
source_group("src\\Math" FILES ${MATH_SOURCES_C})
source_group("src\\Replay" FILES ${REPLAY_SOURCES_C})
source_group("include" FILES ${SOURCES_H})

add_library(srtp2
  ${SOURCES_C}
  ${CIPHERS_SOURCES_C}
  ${HASHES_SOURCES_C}
  ${KERNEL_SOURCES_C}
  ${MATH_SOURCES_C}
  ${REPLAY_SOURCES_C}
  ${SOURCES_H}
)

target_include_directories(srtp2 PUBLIC crypto/include include)
if(ENABLE_OPENSSL)
  target_link_libraries(srtp2 OpenSSL::Crypto)
endif()
if(WIN32)
  target_link_libraries(srtp2 ws2_32)
endif()

install(TARGETS srtp2 DESTINATION lib)
install(FILES include/srtp.h crypto/include/auth.h
  crypto/include/cipher.h
  crypto/include/cipher_types.h
  DESTINATION include/srtp2)

if(TEST_APPS)
  enable_testing()

if(NOT (BUILD_SHARED_LIBS AND WIN32))
  add_executable(test_srtp test/test_srtp.c)
  target_link_libraries(test_srtp srtp2)
  add_test(test_srtp test_srtp)
endif()

  add_executable(srtp_driver test/srtp_driver.c
    test/util.c test/getopt_s.c)
  target_link_libraries(srtp_driver srtp2)
  add_test(srtp_driver srtp_driver -v)
endif()

## libsrtp2 2.0.0+20170123

=== debian/changelog ===
libsrtp2 (2.0.0+20170123-1) unstable; urgency=medium

  [ upstream ]
  * Development snapshot from stable git branch.
    Highlights:
    + Add cast to unsigned int in call to printf.
    + avoid empty initializer braces.
    + Use ps -e  to ensure process is found.

  [ Jonas Smedegaard ]
  * Modernize Vcs-Browser field: Use git subdir (not cgit).
  * Re-enable patch 1005 to fix data alignment.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 24 Jan 2017 13:10:31 +0100

libsrtp2 (2.0.0+20161214-2) unstable; urgency=medium

  * Skip patch 1005, to hopefully fix FTBFS on several archs.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 18 Jan 2017 02:48:05 +0100

libsrtp2 (2.0.0+20161214-1) unstable; urgency=medium

  [ upstream ]
  * Development snapshot from stable git branch.
    Highlights:
    + Make srtp_driver compile for MIPS.
    + Rename srtp_crypto_kernel_replace_cipher_type as
      srtp_replace_cipher_type, and similarly for auth_type.
    + Install cipher.h, auth.h and crypto_types.h.
      Closes: Bug#850266. Thanks to Sebastian Dröge.
    + Changes for OpenSSL 1.1.0 compatibility.

  [ Jonas Smedegaard ]
  * Drop upstream cherry-picked patch since applied.
  * Unfuzz patch 1005.
  * Update copyright info:
    + Extend coverage of autotools files.
    + Extend coverage of Debian packaging.
  * Update watch file:
    + Bump to version 4.
    + Add usage comment.
    + Use github pattern from documentation.
  * Modernize git-buildpackage config: Filter any .git* file.
  * Update symbols: 2 renamed.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 17 Jan 2017 19:47:06 +0100

libsrtp2 (2.0.0-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Fork source package: srtp → libsrtp2.
  * Stop repackage upstream tarball: No longer includes non-DFSG files.
  * Declare compliance with Debian Policy 3.9.8.
  * Modernize Vcs-Git field: Use https protocol.
  * Update copyright info:
    + Extend coverage for main upstream author.
    + Extend copyright of packaging to cover current year.
    + Fix make License-Grant of packaging verbatim.
    + Drop superfluous disclaimers from GPL license grants.
    + Use License short-name FSFUL.
  * Drop patch now included upstream.
  * Unfuzz/update patches 1004 1005.
  * Cherry-pick patch from upstream to fix compilation on MIPS,
    replacing local patch 1003.
  * Move packaging to Debian VoIP Team. Demote myself to uploader.
  * Add symbols file, and enable use of pkgkde-symbolshelper.
    Build-depend on pkg-kde-tools.
  * Build-depend on libpcap0.8-dev (not transitional libpcap-dev).
  * Drop -utils package.
  * Have -dev package suggest -doc package.
  * Add lintian override for embedded-library false positive.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 22 Dec 2016 17:12:14 +0100

srtp (1.5.3~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * New release.
    + Fix for CVE-2015-6360.
    + Makefile.in: Don't hard-code ar.
    + Various fixes for compiling with Visual Studio.
    + Do not duplicate shared library when installing.

  [ Jonas Smedegaard ]
  * Stop juggle library symlinks: Fixed upstream.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 28 Nov 2015 21:08:25 +0100

srtp (1.5.2~dfsg-4) experimental; urgency=medium

  * Stop build-depend on libssl-dev or configure with --enable-openssl.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 30 Jul 2015 10:03:44 +0200

srtp (1.5.2~dfsg-3) experimental; urgency=medium

  * Temporarily(!) build-depend on libssl-dev and configure with
    --enable-openssl.
  * Use globbing in debhelper install list (handling also one test
    binary skipped when building with OpenSSL).

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 29 Jul 2015 12:54:42 +0200

srtp (1.5.2~dfsg-2) experimental; urgency=medium

  * Fix upstream cherry-picked patch.
    Thanks to Jeremy Lainé.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 29 Jul 2015 12:16:46 +0200

srtp (1.5.2~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * New release(s).

  [ Daniel Pocock ]
  * Add myself to uploaders.

  [ Jonas Smedegaard ]
  * Acknowledge NMU, with a few adjustments:
    + Fix revert accidental change to .gitignore.
    + Refresh patch 2002 with shortening quilt options.
    Closes: bug##752970. Thanks to Jonathan Wiltshire.
  * Declare compliance with Debian Policy 3.9.6.
  * Fix use canonical URL in Vcs-Git.
  * Update Vcs-Browser URL to use cgit web frontend.
  * Update copyright info:
    + Extend coverage for main upstream author.
    + Extend coverage for myself to include current year.
    + Use License-Grant and License-Reference fields.
      Thanks to Ben Finney.
    + Drop accidental duplicate License section for GAP~configure.
  * Update hints so get-orig-source target fetches released tarballs.
  * Modernize git-buildpackage config: Drop "git-" prefix.
  * Bump debhelper compatibility level to 9.
  * Add lintian override regarding license in License-Reference field.
    See bug#786450.
  * Provide unversioned libsrtp-dev package (not versioned + virtual).
  * Install pkgconfig file.
    Build-depend on, and have -dev package depend on, pkg-config.
  * Include rtp_decoder in -utils package.
    Build-depend on, and have -dev package depend on, libpcap-dev.
  * Drop patches 1001 1002 1008 applied upstream.
    Unfuzz remaining patches.
  * Add patch cherry-picked upstream renaming SHA1 functions to avoid
    conflicts with e.g. polarssl.
    Closes: bug#764778. Thanks to Si Padmore.
  * Make library package multi-arch aware.
    Closes: bug#765173. Thanks to Michał Mirosław.
  * Drop fallback-build-dependencies for doxygen-latex: Unneeded even in
    oldstable.
  * Fix declare arch-indep build-dependency on doxygen-latex as such.
    Closes: Bug#628559. Thanks to George Danchev.
  * Add -dbg package.
  * Stop use or build-depend on obsolete hardening-includes.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 02 Jun 2015 23:31:26 +0200

srtp (1.4.5~20130609~dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.


=== debian/control ===
Source: libsrtp2
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Jonas Smedegaard <dr@jones.dk>,
 Daniel Pocock <daniel@pocock.com.au>
Build-Depends: cdbs,
 autotools-dev,
 debhelper,
 dh-buildinfo,
 licensecheck,
 pkg-kde-tools,
 pkg-config,
 libpcap0.8-dev,
 procps,
 psmisc,
 miscfiles,
 d-shlibs
Build-Depends-Indep: doxygen-latex
Standards-Version: 3.9.8
Section: libs
Vcs-Git: https://anonscm.debian.org/git/pkg-voip/srtp.git
Vcs-Browser: https://anonscm.debian.org/git/pkg-voip/srtp.git
Homepage: https://github.com/cisco/libsrtp

Package: libsrtp2-dev
Section: libdevel
Depends: ${cdbs:Depends},
 ${devlibs:Depends},
 ${misc:Depends},
 libsrtp2-1 (= ${binary:Version})
Suggests: libsrtp2-docs
Architecture: any
Description: Secure RTP (SRTP) and UST Reference Implementations - development files
 SRTP is a security profile for RTP that adds confidentiality, message
 authentication, and replay protection to that protocol. It is specified
 in RFC 3711.
 .
 LibSRTP provides an implementation of the Secure Real-time Transport
 Protocol (SRTP), the Universal Security Transform (UST), and a
 supporting cryptographic kernel.
 .
 This package contains the development headers and static libraries.

Package: libsrtp2-1
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
 ${shlibs:Depends}
Architecture: any
Multi-Arch: same
Description: Secure RTP (SRTP) and UST Reference Implementations - shared library
 SRTP is a security profile for RTP that adds confidentiality, message
 authentication, and replay protection to that protocol. It is specified
 in RFC 3711.
 .
 LibSRTP provides an implementation of the Secure Real-time Transport
 Protocol (SRTP), the Universal Security Transform (UST), and a
 supporting cryptographic kernel.
 .
 This package contains the shared libraries.

Package: libsrtp2-1-dbg
Section: debug
Priority: extra
Depends: ${misc:Depends},
 libsrtp2-1 (= ${binary:Version})
Architecture: any
Multi-Arch: same
Description: Secure RTP (SRTP) and UST Reference Implementations - debugging symbols
 SRTP is a security profile for RTP that adds confidentiality, message
 authentication, and replay protection to that protocol. It is specified
 in RFC 3711.
 .
 LibSRTP provides an implementation of the Secure Real-time Transport
 Protocol (SRTP), the Universal Security Transform (UST), and a
 supporting cryptographic kernel.
 .
 This package contains the debugging symbols.

Package: libsrtp2-docs
Section: doc
Depends: ${misc:Depends}
Architecture: all
Description: Secure RTP (SRTP) and UST Reference Implementations - documentation
 SRTP is a security profile for RTP that adds confidentiality, message
 authentication, and replay protection to that protocol. It is specified
 in RFC 3711.
 .
 LibSRTP provides an implementation of the Secure Real-time Transport
 Protocol (SRTP), the Universal Security Transform (UST), and a
 supporting cryptographic kernel.
 .
 This package contains API documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2007-2008, 2010-2011, 2013-2017 Jonas Smedegaard
# <dr@jones.dk>
# Description: Main Debian packaging script for libSRTP
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# These must be listed before including CDBS snippets
stem = $(DEB_SOURCE_PACKAGE)
major := $(shell grep ^SHAREDLIBVERSION Makefile.in | grep -o '[[:digit:]]*' | head -n 1)
pkg-lib = $(stem)-$(major)
pkg-dev = $(stem)-dev
pkg-doc = $(stem)-docs
debian/control:: debian/control.in
DEB_PHONY_RULES += debian/control.in
debian/control.in::
	sed \
		-e 's/__LIBPKGNAME__/$(pkg-lib)/g' \
		-e 's/__DEVPKGNAME__/$(pkg-dev)/g' \
		-e 's/__DOCPKGNAME__/$(pkg-doc)/g' \
		< debian/control.in.in \
		> debian/control.in

include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/upstream-tarball.mk

CDBS_BUILD_DEPENDS +=, pkg-kde-tools
include /usr/share/pkg-kde-tools/makefiles/1/cdbs/symbolshelper.mk

libname = $(stem)

DEB_UPSTREAM_URL = https://github.com/cisco/libsrtp/archive
DEB_UPSTREAM_TARBALL_BASENAME = v$(DEB_UPSTREAM_TARBALL_VERSION)

# Needed by upstream build and (always) at (development) runtime
deps-dev = pkg-config, libpcap0.8-dev

# Needed by upstream testsuite
bdeps-test = procps, psmisc, miscfiles

CDBS_BUILD_DEPENDS +=, $(deps-dev), $(bdeps-test)
CDBS_DEPENDS_$(pkg-dev) +=, $(deps-dev)

DEB_CONFIGURE_EXTRA_FLAGS = --disable-stdout --enable-syslog
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
DEB_CONFIGURE_EXTRA_FLAGS += --enable-debug
else
DEB_CONFIGURE_EXTRA_FLAGS += --disable-debug
endif
DEB_CONFIGURE_EXTRA_FLAGS += --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

ifeq ($(DEB_HOST_ARCH_CPU),sparc)
CFLAGS += -DFORCE_64BIT_ALIGN
endif

CFLAGS += -D_REENTRANT

# Reapply default strong optimizations unless noopt in DEB_BUILD_OPTIONS
CFLAGS += $(if $(filter noopt,$(DEB_BUILD_OPTIONS))-O0,-O4 -fexpensive-optimizations -funroll-loops)

DEB_MAKE_BUILD_TARGET = shared_library test
DEB_MAKE_CLEAN_TARGET = superclean
DEB_MAKE_CHECK_TARGET = runtest \
 LD_LIBRARY_PATH="${LD_LIBRARY_PATH}:$(realpath $(DEB_SRCDIR))"

# preserve (and restore) upstream-shipped files tampered with
upstreamtmpfiles = doc/Makefile crypto/Makefile doc/Doxyfile
pre-build:: debian/stamp-upstreamtmpstuff
debian/stamp-upstreamtmpstuff: debian/stamp-copyright-check
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file ] || cp -np $$file $$file.upstream; \
	done
	touch $@
clean::
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file.upstream ] || mv -f $$file.upstream $$file; \
	done
	rm -f debian/stamp-upstreamtmpstuff

# generate (and cleanup) documentation
#  * TODO: Declare build-dependency here when supported by CDBS
CDBS_BUILD_DEPENDS_INDEP +=, doxygen-latex
DEB_INSTALL_DOCS_$(pkg-doc) += doc/*.txt doc/*.pdf
DEB_COMPRESS_EXCLUDE_$(pkg-doc) += .pdf
build/$(pkg-doc)::
	[ -f debian/stamp-make-docs ] || $(DEB_MAKE_INVOKE) $(libname)doc
	touch debian/stamp-make-docs
clean::
	rm -f doc/*.pdf
	rm -f debian/stamp-make-docs

# Ensure test script is executable
post-patches::
	chmod +x test/rtpw_test.sh

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
CDBS_BUILD_DEPENDS +=, d-shlibs
binary-post-install/$(pkg-lib)::
	d-shlibmove --commit \
		--devunversioned \
		--multiarch \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		--movedev "debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/*" \
			usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/$(libname).so

# cleanup stuff missed upstream
clean::
	rm -f $(libname).pc $(libname).so.$(major) doc/doxygen_sqlite3.db crypto/Makefile crypto/test/env doc/Makefile

# relax symbols check for now...
export DPKG_GENSYMBOLS_CHECK_LEVEL=0

## libsrtp2 2.1.0

=== debian/changelog ===
libsrtp2 (2.1.0-1) unstable; urgency=medium

  [ upstream ]
  * New release.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 15 Jun 2017 14:23:53 +0200

libsrtp2 (2.0.0+20170607-1) unstable; urgency=medium

  [ upstream ]
  * Development snapshot from stable git branch.

  [ Jonas Smedegaard ]
  * Update symbols: 3 dropped. 21 added.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 12 Jun 2017 17:41:32 +0200

libsrtp2 (2.0.0+20170516-1) experimental; urgency=medium

  [ upstream ]
  * Development snapshot from stable git branch.

  [ Jonas Smedegaard ]
  * Update copyright info:
    + Extend coverage for main upstream author.
    + Add testsuite file, licensed Expat.
  * Unfuzz patches.
  * Stop put aside documentation during build: No longer shipped
    upstream.
  * Modernize cdbs: Do copyright-check in maintainer script (not during
    build).
  * Update package relations:
    + Relax to build-depend unversioned on cdbs.
    + Stop build-depend on licensecheck libregexp-assemble-perl
      libimage-exiftool-perl libfont-ttf-perl.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 21 May 2017 09:15:50 +0200

libsrtp2 (2.0.0+20170223-1) experimental; urgency=medium

  [ upstream ]
  * Development snapshot from stable git branch.
    Highlights:
    + Support setting tag and key sizes based on RFC 4568 specification.
    + Make the Master Keys dynamic instead of limiting to 4 master keys.
    + Fix RTCP not encrypted only authenticated by AES GCM.
    + Fix memory leak.
    + Change crypto/replay/rdbx.c return types of type int to int32_t.
    + Report ssrc instead of srtp_stream_t in srtp_event_data_t
    + Improve OpenSSL discovery and linking.
    + Replace hardcoded CFLAGS with compiler checks.
    + Simplify logging of errors and debug.
    + Use OPENSSL_cleanse() to set memory to zero, when available.
    + Add simple error checking in timing test to avoid false results.
    + Don't use underscore as leading character in header guards.
    + Free enc_buf if an error occurs
    + Add missing srtp_cipher_dealloc calls when test fails.
    + Change documentation from PDF to HTML.

  [ Jonas Smedegaard ]
  * Fix Vcs-* URLs (was pointing to separate libsrtp 1.x git).
    Closes: Bug#856819. Thanks to Andrey Gursky.
  * Drop upstream cherry-picked patch since applied.
  * Drop patches 1007 2002, obsoleted by upstream documentation changes.
  * Unfuzz patches 1004 1005.
  * Adapt rules to refactored upstream build routines.
    Build-depend on doxygen (not doxygen-latex).
  * Modernize cdbs use:
    + Extract copyrigh/licensing from PNG files.
    + Use cdbs to put aside upstream cruft during build.
    Tighten to build-depend versioned on cdbs.
    Build-depend on + libregexp-assemble-perl libimage-exiftool-perl
    libfont-ttf-perl.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 05 Mar 2017 15:41:00 +0100

libsrtp2 (2.0.0+20170123-2) experimental; urgency=medium

  * Add patch chrry-picked upstream to fix return types of type int to
    int32_t.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 27 Jan 2017 15:05:51 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,6 @@
  autotools-dev,
  debhelper,
  dh-buildinfo,
- licensecheck,
  pkg-kde-tools,
  pkg-config,
  libpcap0.8-dev,
@@ -15,11 +14,11 @@
  psmisc,
  miscfiles,
  d-shlibs
-Build-Depends-Indep: doxygen-latex
+Build-Depends-Indep: doxygen
 Standards-Version: 3.9.8
 Section: libs
-Vcs-Git: https://anonscm.debian.org/git/pkg-voip/srtp.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-voip/srtp.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-voip/libsrtp2.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-voip/libsrtp2.git
 Homepage: https://github.com/cisco/libsrtp
 
 Package: libsrtp2-dev

=== debian/rules ===
--- 
+++ 
@@ -35,7 +35,6 @@
 
 include /usr/share/cdbs/1/class/autotools.mk
 include /usr/share/cdbs/1/rules/debhelper.mk
-include /usr/share/cdbs/1/rules/utils.mk
 include /usr/share/cdbs/1/rules/upstream-tarball.mk
 
 CDBS_BUILD_DEPENDS +=, pkg-kde-tools
@@ -77,30 +76,16 @@
 DEB_MAKE_CHECK_TARGET = runtest \
  LD_LIBRARY_PATH="${LD_LIBRARY_PATH}:$(realpath $(DEB_SRCDIR))"
 
-# preserve (and restore) upstream-shipped files tampered with
-upstreamtmpfiles = doc/Makefile crypto/Makefile doc/Doxyfile
-pre-build:: debian/stamp-upstreamtmpstuff
-debian/stamp-upstreamtmpstuff: debian/stamp-copyright-check
-	for file in $(upstreamtmpfiles); do \
-		[ ! -e $$file ] || cp -np $$file $$file.upstream; \
-	done
+# generate (and cleanup) documentation
+#  * TODO: Declare build-dependency here when supported by CDBS
+CDBS_BUILD_DEPENDS_INDEP +=, doxygen
+DEB_INSTALL_DOCS_$(pkg-doc) += doc/html
+build/$(pkg-doc):: debian/stamp-make-docs
+debian/stamp-make-docs:
+	$(DEB_MAKE_INVOKE) $(libname)doc
 	touch $@
 clean::
-	for file in $(upstreamtmpfiles); do \
-		[ ! -e $$file.upstream ] || mv -f $$file.upstream $$file; \
-	done
-	rm -f debian/stamp-upstreamtmpstuff
-
-# generate (and cleanup) documentation
-#  * TODO: Declare build-dependency here when supported by CDBS
-CDBS_BUILD_DEPENDS_INDEP +=, doxygen-latex
-DEB_INSTALL_DOCS_$(pkg-doc) += doc/*.txt doc/*.pdf
-DEB_COMPRESS_EXCLUDE_$(pkg-doc) += .pdf
-build/$(pkg-doc)::
-	[ -f debian/stamp-make-docs ] || $(DEB_MAKE_INVOKE) $(libname)doc
-	touch debian/stamp-make-docs
-clean::
-	rm -f doc/*.pdf
+	rm -rf doc/html
 	rm -f debian/stamp-make-docs
 
 # Ensure test script is executable
@@ -121,7 +106,7 @@
 
 # cleanup stuff missed upstream
 clean::
-	rm -f $(libname).pc $(libname).so.$(major) doc/doxygen_sqlite3.db crypto/Makefile crypto/test/env doc/Makefile
+	rm -f $(libname).pc $(libname).so.$(major) crypto/Makefile crypto/test/env
 
 # relax symbols check for now...
 export DPKG_GENSYMBOLS_CHECK_LEVEL=0

## libsrtp2 2.2.0

=== debian/changelog ===
libsrtp2 (2.2.0-1) unstable; urgency=medium

  [ upstream ]
  * New release.
    + Fix (S)RTP for big endian machines.
      Closes: Bug#857898. Thanks to Adrian Bunk.

  [ Jonas Smedegaard ]
  * Tighten lintian overrides regarding License-Reference.
  * Unfuzz patches 1004 1005.
  * Stop track upstream source with CDBS (use gpb --uscan).
  * Use package priority optional (not extra).
  * Update Vcs-* fields: Source moved to Salsa.
  * Declare compliance with Debian Policy 4.1.4.
  * Update symbols: 3 dropped. 4 added.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 01 Jun 2018 12:52:39 +0200

=== debian/control ===
--- 
+++ 
@@ -15,10 +15,10 @@
  miscfiles,
  d-shlibs
 Build-Depends-Indep: doxygen
-Standards-Version: 3.9.8
+Standards-Version: 4.1.4
 Section: libs
-Vcs-Git: https://anonscm.debian.org/git/pkg-voip/libsrtp2.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-voip/libsrtp2.git
+Vcs-Git: https://salsa.debian.org/pkg-voip-team/libsrtp2.git
+Vcs-Browser: https://salsa.debian.org/pkg-voip-team/libsrtp2.git
 Homepage: https://github.com/cisco/libsrtp
 
 Package: libsrtp2-dev
@@ -60,7 +60,6 @@
 
 Package: libsrtp2-1-dbg
 Section: debug
-Priority: extra
 Depends: ${misc:Depends},
  libsrtp2-1 (= ${binary:Version})
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -41,9 +41,6 @@
 include /usr/share/pkg-kde-tools/makefiles/1/cdbs/symbolshelper.mk
 
 libname = $(stem)
-
-DEB_UPSTREAM_URL = https://github.com/cisco/libsrtp/archive
-DEB_UPSTREAM_TARBALL_BASENAME = v$(DEB_UPSTREAM_TARBALL_VERSION)
 
 # Needed by upstream build and (always) at (development) runtime
 deps-dev = pkg-config, libpcap0.8-dev

## libsrtp2 2.3.0

=== debian/changelog ===
libsrtp2 (2.3.0-2) unstable; urgency=medium

  * Release targeted unstable.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 27 Dec 2019 22:04:30 +0100

libsrtp2 (2.3.0-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * Fix use canonical Vcs-Browser URL.
  * skip copyright-check fuzzer corpus
  * use https protocol for copyright file format URL
  * unfuzz patches
  * drop Daniel Pocock as uploader;
    thanks for your past contributions
  * stop relax symbols check
  * update symbols file:
    + drop commented out obsolete symbols
    + flag as optional symbols not declared in public headers
    + drop 1 private symbol
    + add 9 public sysmbols
    + add 3 private symbols
  * add patch 2002 to avoid privacy breach in documentation
  * reference DEP-3 documentation in patch headers

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 23 Dec 2019 17:47:06 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Priority: optional
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Jonas Smedegaard <dr@jones.dk>,
- Daniel Pocock <daniel@pocock.com.au>
 Build-Depends: cdbs,
  autotools-dev,
  debhelper,
@@ -23,10 +22,12 @@
 
 Package: libsrtp2-dev
 Section: libdevel
-Depends: ${cdbs:Depends},
+Depends:
  ${devlibs:Depends},
  ${misc:Depends},
- libsrtp2-1 (= ${binary:Version})
+ libpcap0.8-dev,
+ libsrtp2-1 (= ${binary:Version}),
+ pkg-config,
 Suggests: libsrtp2-docs
 Architecture: any
 Description: Secure RTP (SRTP) and UST Reference Implementations - development files

=== debian/rules ===
#!/usr/bin/make -f

stem = $(DEB_SOURCE_PACKAGE)
major := $(shell grep ^SHAREDLIBVERSION Makefile.in | grep -o '[[:digit:]]*' | head -n 1)
pkg-lib = $(stem)-$(major)
pkg-dev = $(stem)-dev
pkg-doc = $(stem)-docs

include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/upstream-tarball.mk

include /usr/share/pkg-kde-tools/makefiles/1/cdbs/symbolshelper.mk

libname = $(stem)

DEB_CONFIGURE_EXTRA_FLAGS = --disable-stdout --enable-syslog
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
DEB_CONFIGURE_EXTRA_FLAGS += --enable-debug
else
DEB_CONFIGURE_EXTRA_FLAGS += --disable-debug
endif
DEB_CONFIGURE_EXTRA_FLAGS += --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

ifeq ($(DEB_HOST_ARCH_CPU),sparc)
CFLAGS += -DFORCE_64BIT_ALIGN
endif

CFLAGS += -D_REENTRANT

# Reapply default strong optimizations unless noopt in DEB_BUILD_OPTIONS
CFLAGS += $(if $(filter noopt,$(DEB_BUILD_OPTIONS))-O0,-O4 -fexpensive-optimizations -funroll-loops)

DEB_MAKE_BUILD_TARGET = shared_library test
DEB_MAKE_CLEAN_TARGET = superclean
DEB_MAKE_CHECK_TARGET = runtest \
 LD_LIBRARY_PATH="${LD_LIBRARY_PATH}:$(realpath $(DEB_SRCDIR))"

# generate (and cleanup) documentation
build/$(pkg-doc):: debian/stamp-make-docs
debian/stamp-make-docs:
	$(DEB_MAKE_INVOKE) $(libname)doc
	touch $@

# Ensure test script is executable
post-patches::
	chmod +x test/rtpw_test.sh

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
binary-post-install/$(pkg-lib)::
	d-shlibmove --commit \
		--devunversioned \
		--multiarch \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		--movedev "debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/*" \
			usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/$(libname).so

=== debian/watch ===
# run "uscan --report" to check or "gpb import-orig --uscan" to update
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
 https://github.com/cisco/libsrtp/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian

## libsrtp2 2.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,11 @@
-cmake_minimum_required(VERSION 2.8)
-
-project(libsrtp2 LANGUAGES C)
-
-set(PACKAGE_VERSION 2.3.0)
-set(PACKAGE_STRING "${CMAKE_PROJECT_NAME} ${PACKAGE_VERSION}")
+cmake_minimum_required(VERSION 3.12)
+
+project(libsrtp2 VERSION 2.4.2 LANGUAGES C)
+
+set(PACKAGE_VERSION ${CMAKE_PROJECT_VERSION})
+set(PACKAGE_STRING "${CMAKE_PROJECT_NAME} ${CMAKE_PROJECT_VERSION}")
+
+list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 
 include(TestBigEndian)
 include(CheckIncludeFile)
@@ -13,7 +15,7 @@
 
 test_big_endian(WORDS_BIGENDIAN)
 
-if (CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
+if (NOT APPLE AND CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
   set (HAVE_X86 TRUE)
 else ()
   set (HAVE_X86 FALSE)
@@ -54,15 +56,44 @@
 set(ERR_REPORTING_STDOUT OFF CACHE BOOL "Enable logging to stdout")
 set(ERR_REPORTING_FILE "" CACHE FILEPATH "Use file for logging")
 set(ENABLE_OPENSSL OFF CACHE BOOL "Enable OpenSSL crypto engine")
+set(ENABLE_MBEDTLS OFF CACHE BOOL "Enable MbedTLS crypto engine")
+set(ENABLE_NSS OFF CACHE BOOL "Enable NSS crypto engine")
 set(TEST_APPS ON CACHE BOOL "Build test applications")
+set(BUILD_WITH_SANITIZERS OFF CACHE BOOL "Adds sanitizer flags to compiler")
 option(BUILD_SHARED_LIBS "Build shared library" OFF)
 
+if(ENABLE_OPENSSL OR ENABLE_MBEDTLS OR ENABLE_NSS)
+  set(USE_EXTERNAL_CRYPTO TRUE)
+else()
+  set(USE_EXTERNAL_CRYPTO FALSE)
+endif()
+
 if(ENABLE_OPENSSL)
+  if(ENABLE_NSS OR ENABLE_MBEDTLS)
+    message(FATAL_ERROR "ssl conflict. can not enable openssl and mbedtls or nss simultaneously.")
+  endif()
   find_package(OpenSSL REQUIRED)
-  include_directories(${OPENSSL_INCLUDE_DIR})
-endif()
-set(OPENSSL ${ENABLE_OPENSSL} CACHE BOOL INTERNAL)
-set(GCM ${ENABLE_OPENSSL} CACHE BOOL INTERNAL)
+  set(OPENSSL ${ENABLE_OPENSSL} CACHE BOOL INTERNAL)
+  set(GCM ${ENABLE_OPENSSL} CACHE BOOL INTERNAL)
+endif()
+
+if(ENABLE_MBEDTLS)
+  if(ENABLE_OPENSSL OR ENABLE_NSS)
+    message(FATAL_ERROR "ssl conflict. can not enable mbedtls and openssl or nss simultaneously.")
+  endif()
+  find_package(MbedTLS REQUIRED)
+  set(MBEDTLS ${ENABLE_MBEDTLS} CACHE BOOL INTERNAL)
+  set(GCM ${ENABLE_MBEDTLS} CACHE BOOL INTERNAL)
+endif()
+
+if(ENABLE_NSS)
+  if(ENABLE_OPENSSL OR ENABLE_MBEDTLS)
+    message(FATAL_ERROR "ssl conflict. can not enable nss and openssl or mbedtls simultaneously.")
+  endif()
+  find_package(NSS REQUIRED)
+  set(NSS ${ENABLE_NSS} CACHE BOOL INTERNAL)
+  set(GCM ${ENABLE_NSS} CACHE BOOL INTERNAL)
+endif()
 
 set(CONFIG_FILE_DIR ${CMAKE_CURRENT_BINARY_DIR})
 include_directories(${CONFIG_FILE_DIR})
@@ -70,13 +101,28 @@
 configure_file(config_in_cmake.h ${CONFIG_FILE_DIR}/config.h)
 add_definitions(-DHAVE_CONFIG_H)
 
+if(BUILD_WITH_SANITIZERS AND NOT WIN32)
+  if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+    set(SANITIZERS address,undefined)
+  else()
+    set(SANITIZERS leak,address,undefined)
+  endif()
+  message(STATUS "Using sanitizers: ${SANITIZERS}")
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
+  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
+  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
+  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
+endif()
+
 set(SOURCES_C
-  srtp/ekt.c
   srtp/srtp.c
 )
 
 set(CIPHERS_SOURCES_C
   crypto/cipher/cipher.c
+  crypto/cipher/cipher_test_cases.c
+  crypto/cipher/cipher_test_cases.h
   crypto/cipher/null_cipher.c
 )
 
@@ -85,24 +131,44 @@
     crypto/cipher/aes_icm_ossl.c
     crypto/cipher/aes_gcm_ossl.c
   )
+elseif(ENABLE_MBEDTLS)
+  list(APPEND CIPHERS_SOURCES_C
+    crypto/cipher/aes_icm_mbedtls.c
+    crypto/cipher/aes_gcm_mbedtls.c
+  )
+elseif(ENABLE_NSS)
+  list(APPEND CIPHERS_SOURCES_C
+    crypto/cipher/aes_icm_nss.c
+    crypto/cipher/aes_gcm_nss.c
+  )
 else()
-  list(APPEND  CIPHERS_SOURCES_C
+  list(APPEND CIPHERS_SOURCES_C
     crypto/cipher/aes.c
     crypto/cipher/aes_icm.c
   )
 endif()
 
 set(HASHES_SOURCES_C
-    crypto/hash/auth.c
-    crypto/hash/null_auth.c
+  crypto/hash/auth.c
+  crypto/hash/auth_test_cases.c
+  crypto/hash/auth_test_cases.h
+  crypto/hash/null_auth.c
 )
 
 if(ENABLE_OPENSSL)
   list(APPEND HASHES_SOURCES_C
     crypto/hash/hmac_ossl.c
   )
+elseif(ENABLE_MBEDTLS)
+  list(APPEND HASHES_SOURCES_C
+    crypto/hash/hmac_mbedtls.c
+  )
+elseif(ENABLE_NSS)
+  list(APPEND HASHES_SOURCES_C
+    crypto/hash/hmac_nss.c
+  )
 else()
-  list(APPEND  HASHES_SOURCES_C
+  list(APPEND HASHES_SOURCES_C
     crypto/hash/hmac.c
     crypto/hash/sha1.c
   )
@@ -117,13 +183,11 @@
 
 set(MATH_SOURCES_C
   crypto/math/datatypes.c
-  crypto/math/stat.c
 )
 
 set(REPLAY_SOURCES_C
   crypto/replay/rdb.c
   crypto/replay/rdbx.c
-  crypto/replay/ut_sim.c
 )
 
 set(SOURCES_H
@@ -145,10 +209,8 @@
   crypto/include/rdb.h
   crypto/include/rdbx.h
   crypto/include/sha1.h
-  crypto/include/stat.h
   include/srtp.h
   include/srtp_priv.h
-  include/ut_sim.h
   ${CONFIG_FILE_DIR}/config.h
 )
 
@@ -176,31 +238,111 @@
   ${SOURCES_H}
 )
 
+set_target_properties(srtp2 PROPERTIES VERSION ${CMAKE_PROJECT_VERSION})
+
 target_include_directories(srtp2 PUBLIC crypto/include include)
 if(ENABLE_OPENSSL)
+  target_include_directories(srtp2 PRIVATE ${OPENSSL_INCLUDE_DIR})
   target_link_libraries(srtp2 OpenSSL::Crypto)
+elseif(ENABLE_MBEDTLS)
+  target_include_directories(srtp2 PRIVATE ${MBEDTLS_INCLUDE_DIRS})
+  target_link_libraries(srtp2 ${MBEDTLS_LIBRARIES})
+elseif(ENABLE_NSS)
+  target_include_directories(srtp2 PRIVATE ${NSS_INCLUDE_DIRS})
+  target_link_libraries(srtp2 ${NSS_LIBRARIES})
 endif()
 if(WIN32)
   target_link_libraries(srtp2 ws2_32)
+  target_compile_definitions(srtp2 PUBLIC _CRT_SECURE_NO_WARNINGS)
 endif()
 
 install(TARGETS srtp2 DESTINATION lib)
 install(FILES include/srtp.h crypto/include/auth.h
   crypto/include/cipher.h
-  crypto/include/cipher_types.h
+  crypto/include/crypto_types.h
   DESTINATION include/srtp2)
 
 if(TEST_APPS)
   enable_testing()
 
-if(NOT (BUILD_SHARED_LIBS AND WIN32))
-  add_executable(test_srtp test/test_srtp.c)
-  target_link_libraries(test_srtp srtp2)
-  add_test(test_srtp test_srtp)
-endif()
+  if(NOT (BUILD_SHARED_LIBS AND WIN32))
+    if(NOT USE_EXTERNAL_CRYPTO)
+      add_executable(aes_calc crypto/test/aes_calc.c test/getopt_s.c test/util.c)
+      target_include_directories(aes_calc PRIVATE test)
+      target_link_libraries(aes_calc srtp2)
+      add_test(aes_calc_128 aes_calc 000102030405060708090a0b0c0d0e0f
+                                     00112233445566778899aabbccddeeff
+                                     69c4e0d86a7b0430d8cdb78070b4c55a)
+      add_test(aes_calc_256 aes_calc 000102030405060708090a0b0c0d0e0f101112131415161718191a1b1c1d1e1f
+                                     00112233445566778899aabbccddeeff
+                                     8ea2b7ca516745bfeafc49904b496089)
+
+      add_executable(sha1_driver crypto/test/sha1_driver.c test/util.c)
+      target_include_directories(sha1_driver PRIVATE test)
+      target_link_libraries(sha1_driver srtp2)
+      add_test(sha1_driver sha1_driver -v)
+    endif()
+
+    add_executable(datatypes_driver crypto/test/datatypes_driver.c test/util.c)
+    target_include_directories(datatypes_driver PRIVATE test)
+    target_link_libraries(datatypes_driver srtp2)
+    add_test(datatypes_driver datatypes_driver -v)
+
+    add_executable(cipher_driver crypto/test/cipher_driver.c test/getopt_s.c)
+    target_include_directories(cipher_driver PRIVATE test)
+    target_link_libraries(cipher_driver srtp2)
+    add_test(cipher_driver cipher_driver -v)
+
+    add_executable(kernel_driver crypto/test/kernel_driver.c test/getopt_s.c)
+    target_include_directories(kernel_driver PRIVATE test)
+    target_link_libraries(kernel_driver srtp2)
+    add_test(kernel_driver kernel_driver -v)
+
+    add_executable(rdbx_driver test/rdbx_driver.c test/getopt_s.c test/ut_sim.c)
+    target_include_directories(rdbx_driver PRIVATE test)
+    target_link_libraries(rdbx_driver srtp2)
+    add_test(rdbx_driver rdbx_driver -v)
+
+    add_executable(replay_driver test/replay_driver.c test/ut_sim.c)
+    target_include_directories(replay_driver PRIVATE test)
+    target_link_libraries(replay_driver srtp2)
+    add_test(replay_driver replay_driver -v)
+
+    add_executable(roc_driver test/roc_driver.c test/ut_sim.c)
+    target_include_directories(roc_driver PRIVATE test)
+    target_link_libraries(roc_driver srtp2)
+    add_test(roc_driver roc_driver -v)
+  endif()
 
   add_executable(srtp_driver test/srtp_driver.c
     test/util.c test/getopt_s.c)
   target_link_libraries(srtp_driver srtp2)
   add_test(srtp_driver srtp_driver -v)
-endif()
+
+  if(NOT (BUILD_SHARED_LIBS AND WIN32))
+    add_executable(test_srtp test/test_srtp.c)
+    if(ENABLE_OPENSSL)
+      target_include_directories(test_srtp PRIVATE ${OPENSSL_INCLUDE_DIR})
+    elseif(ENABLE_MBEDTLS)
+      target_include_directories(test_srtp PRIVATE ${MBEDTLS_INCLUDE_DIRS})
+    elseif(ENABLE_NSS)
+      target_include_directories(test_srtp PRIVATE ${NSS_INCLUDE_DIRS})
+    endif()
+    target_link_libraries(test_srtp srtp2)
+    add_test(test_srtp test_srtp)
+  endif()
+
+  find_program(BASH_PROGRAM bash)
+  if(BASH_PROGRAM AND NOT WIN32)
+    add_executable(rtpw test/rtpw.c test/rtp.c test/util.c test/getopt_s.c)
+    target_link_libraries(rtpw srtp2)
+    add_test(NAME rtpw_test
+             COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test/rtpw_test.sh -w ${CMAKE_CURRENT_SOURCE_DIR}/test/words.txt
+             WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
+    if(GCM)
+      add_test(NAME rtpw_test_gcm
+               COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test/rtpw_test_gcm.sh -w ${CMAKE_CURRENT_SOURCE_DIR}/test/words.txt
+               WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
+    endif()
+  endif()
+endif()

=== meson_options.txt ===
option('debug-logging', type : 'boolean', value : false,
  description : 'Enable debug logging in all modules')
option('log-stdout', type : 'boolean', value : false,
  description : 'Redirect logging to stdout')
option('log-file', type : 'string', value : '',
  description : 'Write logging output into this file')
option('crypto-library', type: 'combo', choices : ['none', 'openssl', 'nss'], value : 'none',
  description : 'What external crypto library to leverage, if any (OpenSSL or NSS)')
option('crypto-library-kdf', type : 'feature', value : 'auto',
  description : 'Use the external crypto library for Key Derivation Function support')
option('fuzzer', type : 'feature', value : 'disabled',
  description : 'Build libsrtp2 fuzzer (requires build with clang)')
option('tests', type : 'feature', value : 'auto', yield : true,
  description : 'Build test applications')
option('pcap-tests', type : 'feature', value : 'auto',
  description : 'Build test application that require libpcap')
option('doc', type : 'feature', value : 'auto', yield : true,
  description : 'Generate API documentation with doxygen')

=== debian/changelog ===
libsrtp2 (2.4.2-2) unstable; urgency=medium

  * fix stop depend (only build-depend) on libpcap0.8-dev
    (used only for tests);
    closes: bug#996979, thanks to Alexander Traud
  * update copyright info: update coverage

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 22 Oct 2021 21:08:54 +0200

libsrtp2 (2.4.2-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * use semantic newlines in long description and copyright fields
  * unfuzz patch 1005

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 07 Oct 2021 23:40:37 +0200

libsrtp2 (2.4.1-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * simplify source helper script copyright-check
  * update copyright info:
    + use Reference field (not License-Reference);
      tighten lintian overrides
    + update coverage
  * update symbols file

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 13 Sep 2021 23:59:39 +0200

libsrtp2 (2.4.0-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * drop patches cherry-picked upstream since applied
  * update and unfuzz patches
  * declare compliance with Debian Policy 4.6.0

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 18 Aug 2021 16:03:15 +0200

libsrtp2 (2.3.0-5) unstable; urgency=medium

  * add patch cherry-picked upstream
    to support running against nss >= 3.52;
    closes: bug#963363, thanks to Juhani Numminen

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 07 Feb 2021 04:11:43 +0100

libsrtp2 (2.3.0-4) unstable; urgency=medium

  * use NSS crypto;
    build-depend on libnss3-dev;
    tighten build-dependency on d-shlibs
  * update symbols:
    + 5 optional symbols dropped
    + 4 optional symbols added

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 06 Apr 2020 17:29:46 +0200

libsrtp2 (2.3.0-3) unstable; urgency=medium

  * add patch cherry-picked upstream
    to fix building with gcc-10
  * simplify rules: stop build-depend on dh-buildinfo
  * use debhelper compatibility level 10 (not 9);
    stop build-depend explicitly on autotools-dev
  * declare compliance with Debian Policy 4.5.0
  * set Rules-Requires-Root: no
  * watch:
    + simplify regular expression;
    + use dversionmangle=auto (although currently dormant);
    + rewrite usage comment

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 25 Mar 2020 15:46:35 +0100

=== debian/control ===
Source: libsrtp2
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Jonas Smedegaard <dr@jones.dk>,
Build-Depends: cdbs,
 debhelper,
 pkg-kde-tools,
 pkg-config,
 libnss3-dev,
 libpcap0.8-dev <!nocheck>,
 procps,
 psmisc,
 miscfiles,
 d-shlibs (>= 0.91~),
Build-Depends-Indep: doxygen
Standards-Version: 4.6.0
Section: libs
Vcs-Git: https://salsa.debian.org/pkg-voip-team/libsrtp2.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/libsrtp2.git
Homepage: https://github.com/cisco/libsrtp
Rules-Requires-Root: no

Package: libsrtp2-dev
Section: libdevel
Depends:
 ${devlibs:Depends},
 ${misc:Depends},
 libsrtp2-1 (= ${binary:Version}),
 pkg-config,
Suggests: libsrtp2-docs
Architecture: any
Description: Secure RTP (SRTP) and UST Reference Implementations - development files
 SRTP is a security profile for RTP
 that adds confidentiality, message authentication, and replay protection
 to that protocol.
 It is specified in RFC 3711.
 .
 LibSRTP provides an implementation
 of the Secure Real-time Transport Protocol (SRTP),
 the Universal Security Transform (UST),
 and a supporting cryptographic kernel.
 .
 This package contains the development headers and static libraries.

Package: libsrtp2-1
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
 ${shlibs:Depends}
Architecture: any
Multi-Arch: same
Description: Secure RTP (SRTP) and UST Reference Implementations - shared library
 SRTP is a security profile for RTP
 that adds confidentiality, message authentication, and replay protection
 to that protocol.
 It is specified in RFC 3711.
 .
 LibSRTP provides an implementation
 of the Secure Real-time Transport Protocol (SRTP),
 the Universal Security Transform (UST),
 and a supporting cryptographic kernel.
 .
 This package contains the shared libraries.

Package: libsrtp2-1-dbg
Section: debug
Depends: ${misc:Depends},
 libsrtp2-1 (= ${binary:Version})
Architecture: any
Multi-Arch: same
Description: Secure RTP (SRTP) and UST Reference Implementations - debugging symbols
 SRTP is a security profile for RTP
 that adds confidentiality, message authentication,
 and replay protection to that protocol.
 It is specified in RFC 3711.
 .
 LibSRTP provides an implementation of the Secure Real-time Transport
 Protocol (SRTP), the Universal Security Transform (UST), and a
 supporting cryptographic kernel.
 .
 This package contains the debugging symbols.

Package: libsrtp2-docs
Section: doc
Depends: ${misc:Depends}
Architecture: all
Description: Secure RTP (SRTP) and UST Reference Implementations - documentation
 SRTP is a security profile for RTP that adds confidentiality, message
 authentication, and replay protection to that protocol. It is specified
 in RFC 3711.
 .
 LibSRTP provides an implementation
 of the Secure Real-time Transport Protocol (SRTP),
 the Universal Security Transform (UST),
 and a supporting cryptographic kernel.
 .
 This package contains API documentation.

=== debian/rules ===
--- 
+++ 
@@ -21,6 +21,8 @@
 DEB_CONFIGURE_EXTRA_FLAGS += --disable-debug
 endif
 DEB_CONFIGURE_EXTRA_FLAGS += --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
+
+DEB_CONFIGURE_EXTRA_FLAGS += --enable-nss
 
 ifeq ($(DEB_HOST_ARCH_CPU),sparc)
 CFLAGS += -DFORCE_64BIT_ALIGN
